CREATE OR REPLACE VIEW V_S_INVENTURA AS (
SELECT SA.ID_INVENTURA, SA.DATUM, SA.STATUS, SA.ID_LOKACIJA, SA.UPORABNIK, SA.DT_KREIRANJA,
SL.NAZIV AS LOKACIJE_NAZIV
FROM S_INVENTURA SA
LEFT OUTER JOIN S_LOKACIJE SL ON SL.ID_LOKACIJA = SA.ID_LOKACIJA
);

CREATE OR REPLACE VIEW V_S_INV_PROMET AS (
SELECT SIP.ID_INV_PROMET, SIP.ID_INVENTURA, SIP.ID_ARTIKEL, SIP.ID_ENOTA, SIP.KOLICINA, SIP.ZALOGA, SIP.UPORABNIK, SIP.DT_VNOSA,
SA.NAZIV AS S_ARTIKLI_NAZIV, SA.NAZIV1 AS S_ARTIKLI_NAZIV1, SE.NAZIV AS S_ENOTE_NAZIV, SG.ID_GRUPA AS S_GRUPE_ID_GRUPA, SG.NAZIV AS S_GRUPE_NAZIV
FROM S_INV_PROMET SIP
LEFT OUTER JOIN S_ARTIKLI SA ON SA.ID_ARTIKEL = SIP.ID_ARTIKEL
LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SIP.ID_ENOTA
LEFT OUTER JOIN S_GRUPE SG ON SG.ID_GRUPA = SA.ID_GRUPA
);

DROP VIEW V_STORITVE;

CREATE OR REPLACE VIEW V_STORITVE AS (
	SELECT M.ID_STORITVE, M.ID_DN, M.ID_POGODBE, M.ID_VPS, M.VRSTA, M.ID_LASTNIKA, M.ID_PLOVILA, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_OD, M.DATUM_DO, M.KOLICINA, M.POPUST, M.OPIS_SERVIS,
  M.ZNESEK, M.VALUTA, M.TECAJ, M.DAVEK, M.N_PONUDBE, M.N_RACUNA, M.DATUM_RACUNA, M.ZAKLJUCEN, M.KOMENTAR, M.DATUM_KREIRANJA, M.USER_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_SPREMEMBE, M.TIP_SERVIS, M.AUTO,
  M.POPUST1, M.POPUST2, M.NAMENP, M.NAMENP1, M.NAMENP2, M.TECAJP, M.DODATNA_STORITEV, M.DOMACA_VALUTA, M.PROVIZIJA, M.DRZAVA, M.SKUPAJ_OSEB, M.ID_KAT, M.PROVIZIJA_DELITEV, M.ID_REZERVACIJE, M.CUSTOM,
  M.CPROVIZIJA, M.SERVICE_COST, M.COMPLETE, M.KOLICINA_INSTR, M.ID_STORITVE_GEN, M.ID_BATCH, M.ID_SALDKONT, M.ID_LASTNIKA_ORG, M.NNLOCATION_ID, M.MIN_FEE, M.ID_LASTNIK_LEASE, 
  M.NCARD, M.FULL_AMOUNT, M.SERVICE_TIME, M.ID_PRIVEZ, M.SUBLEASE_PAYMENT, M.ID_DAVEK, M.LASTNIK_LEASE_PROCENT, M.ID_REZERVACIJE_CHARTER, M.ID_SERVICE_TEMPLATE, M.CAS_OD, M.CAS_DO, M.USER_COMMENT, M.SERVICE_COMMENT,
  M.ID_OWNER_SIGNATURE, M.ID_NAJAVE, M.SORT, M.ID_IMPORT_BATCH, M.CALCULATING, M.CALCULATED_TO, M.ID_STORITVE_STORNO,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER,
  NS.DEPARTURE_CHECK AS NNSTOMAR_DEPARTURE_CHECK, NS.NIGHTS_PRICE AS NNSTOMAR_NIGHTS_PRICE,
  NNE.OPIS AS NNSTOMAR_ENOTA_OPIS, NNE.INTERNI_OPIS AS NNSTOMAR_ENOTA_INTERNI_OPIS, MDN.DATUM_DN AS M_DE_NA_DATUM_DN, MDN.TERMIN_DO AS M_DE_NA_TERMIN_DO, MDN.STEVILKA AS M_DE_NA_STEVILKA,
  MDN.STATUS AS M_DE_NA_STATUS, MDN.ORG_STATUS AS M_DE_NA_ORG_STATUS, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, KU.MANAGER AS KUPCI_MANAGER, KU.VRSTA AS KUPCI_VRSTA, PL.IME AS PLOVILA_IME
	FROM M_STORITVE M
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NNE ON NNE.SIFRA = NS.ENOTA
  LEFT OUTER JOIN M_DE_NA MDN ON MDN.ID_DN = M.ID_DN
  LEFT OUTER JOIN KUPCI KU ON KU.ID = M.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = M.ID_PLOVILA
);

ALTER TABLE M_VZORCI_PS
ADD VALUTA VARCHAR2(3 CHAR);

CREATE OR REPLACE VIEW V_M_VZORCI_PS AS (
  SELECT M.ID, M.LETO, M.ID1, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_ZACETKA, M.DATUM_KONCA, M.ID_VPS, M.ID_POGODBE, M.SKUPAJ, M.DATUM_OBRACUNA, M.OBRACUNANO, M.POPUST, M.DAVEK, M.KOLICINA, M.POPUST1, M.POPUST2, M.KOMENTAR, M.DOMACA_VALUTA,
  M.PROVIZIJA, M.TECAJ, M.STORNO, M.AUTO, M.DODATNA_STORITEV, M.DATUM_PONUDBE, M.KOLICINA_INSTR, M.ZAPOREDJE, M.AUTO_CREATE_METHOD, M.AUTO_CREATE_DAY, M.NEXT_AUTO_DATE, M.ACTIVE, M.AMOUNT_DAY, M.AMOUNT_MONTH, M.NAMENP, M.NAMENP1, M.NAMENP2, M.ID_PRIVEZ,
  M.DATUM_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_KREIRANJA, M.USER_SPREMEMBE, M.ID_DAVEK, M.USER_COMMENT, M.SERVICE_COMMENT, M.FULL_AMOUNT, M.SORT, M.VALUTA,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER
  FROM M_VZORCI_PS M
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1418, SYSDATE, '5.5', 1338, 'Inventura in storitve')
;