CREATE TABLE PARAMETER_DATA (
ID_PARAMETER_DATA NUMBER NOT NULL,
ID_LASTNIKA NUMBER,
ID_PLOVILA NUMBER,
ID_HASH VARCHAR2(50 CHAR),
CONSTRAINT PARAMETER_DATA_ID_LASTNIKA_FK FOREIGN KEY (ID_LASTNIKA) REFERENCES KUPCI(ID),
CONSTRAINT PARAMETER_DATA_ID_PLOVILA_FK FOREIGN KEY (ID_PLOVILA) REFERENCES PLOVILA(ID),
CONSTRAINT PARAMETER_DATA_PK PRIMARY KEY(ID_PARAMETER_DATA)
);

ALTER TABLE PARAMETER_DATA
ADD USER_CREATED VARCHAR2(250 CHAR); 

ALTER TABLE PARAMETER_DATA
ADD DATE_CREATED DATE;


CREATE SEQUENCE PARAMETER_DATA_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;


CREATE TABLE PARAMETER_DATA_DETAIL (
	ID_PARAMETER_DATA_DETAIL NUMBER NOT NULL,
	ID_PARAMETER_DATA NUMBER NOT NULL,
	ID_SALDKONT NUMBER,
    ID_DN NUMBER,
    CONSTRAINT PDD_ID_PARAMETER_DATA_FK FOREIGN KEY (ID_PARAMETER_DATA) REFERENCES PARAMETER_DATA(ID_PARAMETER_DATA),
	CONSTRAINT PDD_ID_SALDKONT_FK FOREIGN KEY (ID_SALDKONT) REFERENCES SALDKONT(ID_SALDKONT),
	CONSTRAINT PDD_ID_DN_FK FOREIGN KEY (ID_DN) REFERENCES M_DE_NA(ID_DN),
	CONSTRAINT PARAMETER_DATA_DETAIL_PK PRIMARY KEY (ID_PARAMETER_DATA_DETAIL)
);

CREATE SEQUENCE PARAMETER_DATA_DETAIL_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE NNEMAIL_TEMPLATE_TYPE
ADD TABLE_NAME VARCHAR2(50 CHAR);

ALTER TABLE NNEMAIL_TEMPLATE_TYPE
ADD COLUMN_NAME VARCHAR2(50 CHAR);

INSERT INTO NNEMAIL_TEMPLATE_TYPE(SIFRA, OPIS, INTERNI_OPIS, TABLE_NAME, COLUMN_NAME, AKT) VALUES
('IGP', 'Invoice group (multiple parameters)', 'Invoice group (multiple parameters)', 'PARAMETER_DATA', 'ID_PARAMETER_DATA', 'Y');

UPDATE NNEMAIL_TEMPLATE_TYPE
SET OPIS = 'Invoice group (single parameter)', INTERNI_OPIS = 'Invoice group (single parameter)'
WHERE SIFRA = 'IVG' AND OPIS = 'Invoice group' AND INTERNI_OPIS = 'Invoice group';

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'NAJAVE', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('PCO', 'POC', 'PCD', 'CPL', 'CPD', 'CPU')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'M_DE_NA', COLUMN_NAME = 'ID_DN'
WHERE SIFRA IN ('OCC', 'POR', 'PWS')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'M_POGODBE', COLUMN_NAME = 'ID_POGODBE'
WHERE SIFRA IN ('CIN', 'COA', 'PCS', 'PCC')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'M_POGODBE', COLUMN_NAME = 'LIST ID_POGODBE'
WHERE SIFRA IN ('CTS')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'SALDKONT', COLUMN_NAME = 'ID_SALDKONT'
WHERE SIFRA IN ('MST', 'INV', 'INVPDF', 'POP')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'SALDKONT', COLUMN_NAME = 'LIST ID_SALDKONT'
WHERE SIFRA IN ('INVGEN')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'REZERVAC', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('RES', 'BRE', 'BFD', 'PNR', 'PNH', 'PRC', 'RCE', 'RCO')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'M_STORITVE', COLUMN_NAME = 'ID_STORITVE'
WHERE SIFRA IN ('PSS')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'REZERVACIJE', COLUMN_NAME = 'ID_REZERVACIJE'
WHERE SIFRA IN ('CHR', 'PCB')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'KUPCI', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('IVG', 'PUS', 'PUF', 'TPE', 'POD', 'PUR')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'PLOVILA', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('PVD')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'DATOTEKE_PLOVIL', COLUMN_NAME = 'ID_DATOTEKE_PLOVIL'
WHERE SIFRA IN ('PUD')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'SC_EVENTPAR', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('PFU', 'PFO', 'PEC', 'SCE')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'SC_EVENT', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('EBI', 'WGN', 'CLC', 'WPO')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'QUESTIONNAIRE_ANSWER_MASTER', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('CQS', 'CQC')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'ASSISTANCE', COLUMN_NAME = 'ID'
WHERE SIFRA IN ('POA')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

UPDATE NNEMAIL_TEMPLATE_TYPE
SET TABLE_NAME = 'RACUNI_KUPCEV', COLUMN_NAME = 'ID_RACUNA'
WHERE SIFRA IN ('DSC')  AND TABLE_NAME IS NULL AND COLUMN_NAME IS NULL;

CREATE OR REPLACE
TRIGGER PARAMETER_DATA_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON PARAMETER_DATA
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_PARAMETER_DATA || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2034, SYSDATE, '5.5', 1954, 'Parameter data')
;
